#!/usr/bin/perl  -w
use strict;
use DBI;
use Getopt::Long;


#definition of variables
my $db="wifiaviso";
my $host="localhost";
my $table="";
my $user="cbisowifi";
my $password="AZEF54m5";
my $interval = 5;
my $time = localtime time;
my $pretime = localtime (time - $interval * 60);

my $state = "OK";

GetOptions ("b=s" => \$db,    # numeric
             "table=s"   => \$table,      # string
             "host=s"   => \$host,      # string
             "user=s"   => \$user,      # string
             "password=s"   => \$password,      # string
             "interval=s"   => \$interval)      # string
or die("Error in command line arguments\n");

my %ERRORS=('OK'=>0,'WARNING'=>1,'CRITICAL'=>2,'UNKNOWN'=>3,'DEPENDENT'=>4);

#connect to MySQL database
my $dbh = DBI->connect ("DBI:mysql:database=$db:host=$host",$user,$password, {PrintError => 0});

if (!$dbh) {
        print "CRITICAL ERROR - Unable to connect to database $db with user $user - $DBI::errstr";
        exit $ERRORS{"CRITICAL"};
}

my $stmt = "SELECT * FROM $table";
               
#prepare the query
my $sth = $dbh->prepare($stmt);

#execute the query
if (!$sth->execute()) {
        print "CRITICAL ERROR - Unable to execute query on $db";
        exit $ERRORS{"CRITICAL"};
}

my $results = $sth->rows;

if ($sth->err()) {
        print "CRITICAL ERROR - Error in retrieving results on $db";
        exit $ERRORS{"CRITICAL"};
}

#Check for new entry count
if ($results == 1) {
        print "OK - $results new entry in $db in $interval minutes ";
} elsif ($results <= 30) {
        print "OK - $results new entry in $db in $interval minutes ";
} elsif ($results <= 60) {
        print "WARNING - $results new entry in $db in $interval minutes ";
        $state = "WARNING";
} else {
        print "CRITICAL - $results new entry in $db in $interval minutes ";
        $state = "CRITICAL";
}


print " | entries=$results";

$sth->finish();
$dbh->disconnect();
exit $ERRORS{$state};
